#!/bin/bash

#-----------------------------
# Shell-Kommando "etl_dosql"
#-----------------------------

#-------------------------------------------------------------------
# Shellvariablen setzen und SQL-Anweisung(en) aus Datei
#  in der SuperX-Datenbank ausfuehren.
#-------------------------------------------------------------------
#13.12.07 DQ Freemarker-Parsing auch mandantenfähig
#9.12.06 MB Erweiterung für Freemarker-Parsing
if [ "$1" = "" ]
   then echo "Aufruf: etl_dosql <Dateiname> <header (true|false)>(optional) <Ausgabedatei> (optional) <Parameter> (optional, nur bei SX_CLIENT=jdbc)"
	echo " "
	echo "Aktion: etl_dosql führt die Kommandos in der Datei <Dateiname> aus."
	echo "Das Ergebnis kann mit Feldnamen (<header=true>) in  eine Datei <Ausgabedatei> ausgegeben werden"
	echo " "
	exit 0
fi
#. $SUPERX_DIR/db/bin/SQL_ENV
filename="$1"
header=$2
outfile=$3
params=$4

fgrep -i -s "freemarker template" $filename > /dev/null
FLAG1=$?
fgrep -i -s "FREEMARKER TEMPLATE" $filename > /dev/null
FLAG2=$?

orgfilename="$filename"
tmpfilename="$filename"$MANDANTID.tmp$MANDANTENID.sql
if [ $FLAG1 -eq 0 -o $FLAG2 -eq 0  ]
then
rm -f $tmpfilename

	
#Anlegen einer temp. Kopie filename.tmp$MANDANTENID.sql
java -cp $JDBC_CLASSPATH $JAVA_OPTS de.superx.bin.FMParser -dbproperties:$DB_PROPERTIES -in:$filename -out:$tmpfilename
if [ ! -f $tmpfilename ]
then
echo "Error : etl_dosql abgebrochen"
exit 1
fi

filename="$tmpfilename"
fi

fgrep -i -s "<xupdate>" $filename > /dev/null
FLAG1=$?
if [ $FLAG1 -eq 0   ]
then
	CP=".:$JDBC_CLASSPATH:$XML_CLASSPATH"
	if [ "$LANG" != "" ]
		then LOCALE="-Duser.language=$LANG"
	fi
	java $LOCALE -cp $CP $JAVA_OPTS de.superx.elt.bin.Dosql -logger:$LOGGER_PROPERTIES -dbproperties:$DB_PROPERTIES -sqlfile:"$filename" -outFormat:"txt" -delim:$DBDELIMITER -header:$header -outfile:$outfile -params:$params

else
case $SX_CLIENT in

jdbc)
	CP=".:$JDBC_CLASSPATH:$XML_CLASSPATH"
	if [ "$LANG" != "" ]
		then LOCALE="-Duser.language=$LANG"
	fi
	java $LOCALE -cp $CP $JAVA_OPTS de.superx.elt.bin.Dosql -logger:$LOGGER_PROPERTIES -dbproperties:$DB_PROPERTIES -sqlfile:"$filename" -outFormat:"txt" -delim:$DBDELIMITER -header:$header -outfile:$outfile  -params:$params

;;
psql)
if [ "$header" != "true" ]
then
	tuples_only='-t'
fi

if [ "$outfile" = "" ]
then
	psql --dbname $DBNAME -f $filename $tuples_only

else
	echo "Ergebnis mit Fieldsep $DBDELIMITER klappt mit psql noch nicht"
	echo "Bitte benutzen Sie SX_CLIENT=jdbc"
	psql --dbname $DBNAME -P fieldsep="$DBDELIMITER" -f $filename $tuples_only -o $outfile

fi

;;	
dbaccess)
if [ "$header" = "true" ]
then
	echo "Mit dbaccess ist kein Export der Feldnamen möglich"
	exit 0
fi

if [ "$outfile" = "" ]
then
	$INF_BIN/dbaccess $DBACCESS_PARAMS $DBNAME $filename
else
 	$INF_BIN/dbaccess $DBACCESS_PARAMS $DBNAME $filename >$outfile
fi

;;
hsql)
	java -Xmx300M -cp .:$JDBC_CLASSPATH org.hsqldb.util.ScriptTool  -database joolap -user admin -password ???? -script $filename
esac
fi

if [ -f $tmpfilename -a "$FM_DEBUG" == "" ]
then
echo 
#Zum Debuggen auskommentieren:
rm -f "$tmpfilename"
fi

