#!/bin/bash
#---------------------------------------------------------------------
# Shell-Kommando "etl_sx_unload_records.x"
#
# Erstellt von D. Quathamer am 6.1.2020
#---------------------------------------------------------------------
if [ "$1" = "" ]
   then echo "Aufruf: etl_sx_unload_records.x <tabelle> <exportdatei>(optional) <format (txt|html|xml)>(optional) <header (true|false)>(optional)  "
	echo " "
	echo "Aktion: etl_sx_unload_records.x entlädt Inhalte einer Tabelle "
	echo "Die Ausgabeformate sind txt (default), html und xml "
	echo "html und xml sind nur möglich,wenn java installiert ist und JAVA_HOME gesetzt ist."
	echo "Der Dateiname ist optional"
	echo " "
	exit 1
fi

table=$1
filename=$2
outformat=$3
header=$4
currpath=`pwd`
UNLLOG=$currpath/unload.err

if [ "$filename" = "" ]
	then filename="$currpath/$table.unl"
fi
if [ "$header" = "" ]
	then header="false"
fi
if [ "$outformat" = "" ]
	then outformat="txt"
fi
if [ "$LANG" != "" ]
	then LOCALE="-Duser.language=$LANG"
fi


CP=".:$JDBC_CLASSPATH"

echo "Unload $table to $filename"


java $LOCALE -cp "$CP" de.superx.elt.bin.Doquery $LOGGER_PROPERTIES $DB_PROPERTIES 'select * from '$table $outformat $DBDELIMITER $header $filename


