#!/bin/bash
#---------------------------------------------------------------------
# Shell-Kommando "etl_sx_upload_records.x"
#
# Erstellt von D. Quathamer am 6.1.2020
#---------------------------------------------------------------------


if [ "$1" = "" ]
   then echo "Aufruf: etl_sx_upload_records.x <tabellenname> <Quelldatei>(optional,Default ist Tabellenname+.unl) <header (true|false)>(optional) <informat (txt|xml>(optional) <encoding (utf8,ISO-8859-1)>(optional)"
	echo " "
	echo "Aktion: etl_sx_upload_records.x lädt von einer Quelldatei in die Tabelle"
	echo " "
	exit 0
fi

tabelle=$1
quelldatei=$2
header=$3
informat=$4
encoding=$5

if [ "$encoding" = "" ]
then 
	if [ "$LANG" = "de_DE@euro" ]
	then
		encoding=ISO-8859-1
	fi
	if [ "$LANG" = "de_DE.utf8" ]
	then
		encoding=UTF-8
	fi
fi

if [ "$2" = "" ]
then
	quelldatei=$tabelle.unl
fi

echo "$tabelle wird aus der Datei $quelldatei gefüllt"
CP=".:$JDBC_CLASSPATH"

CMD="java $JAVA_OPTS -cp $CP de.superx.elt.bin.UploadRecords -logger:$LOGGER_PROPERTIES -dbproperties:$DB_PROPERTIES -table:$tabelle -unl:$quelldatei -delim:$DBDELIMITER -header:$header -informat:$informat -encoding:$encoding"

$CMD

