<?xml version="1.0"  encoding="UTF-8" ?>

<xsl:stylesheet version="2.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:param name="sx_client"/>
<xsl:param name="dbsystem"/>
<xsl:param name="jobtype"/>

<xsl:output method="text" name="text"/>
<xsl:variable name="unknown_id" select="999999" />
<xsl:variable name="unknown" select="Unbekannt" />
<xsl:variable name="singleQuote">&#39;</xsl:variable>
<xsl:variable name="doubleQuote">&quot;</xsl:variable>
<xsl:variable name="doubledSingleQuote">&#39;&#39;</xsl:variable>
<xsl:template match="/">

<xsl:text><![CDATA[
--Freemarker Template 
--Erzeugt von $ETL_PFAD/conf/etl_step_fuellen.xsl
<#include "ETL_MAKROS"/>
<sqlvars>
<sqlvar name="etl_step_exists">
select  sp_table_exists('etl_step') from xdummy;
</sqlvar>
</sqlvars>
]]></xsl:text>

<xsl:choose>
<xsl:when test="$jobtype='patch'">
<xsl:variable name="job_uniquename" select="concat(/patch/module/@name,'_patch_', /patch/@patch_id)" />
<xsl:variable name="logfile" select="concat('L_',/patch/module/@name,'_Patch.log')" />
<xsl:call-template name="initJob">
<xsl:with-param name="modulkuerzel" select="/patch/module/@name"/>
<xsl:with-param name="uniquename" select="$job_uniquename" />
<xsl:with-param name="caption"  select="concat(/patch/module/@name,' Patch ', /patch/@patch_id)" />
<xsl:with-param name="systeminfo_id"  select="/patch/module/@systeminfo_id"/>
<xsl:with-param name="logfile"  select="concat('L_',/patch/module/@name,'_Patch.log')" />
</xsl:call-template>
<!--insert the root step-->
  
<xsl:text><![CDATA[
<#assign  etl_steps = [
]]></xsl:text>


<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="$job_uniquename"/>
	<xsl:with-param name="parent_uniquename" select="''"/>
	<xsl:with-param name="job_uniquename" select="$job_uniquename"/>
	<xsl:with-param name="caption" select="concat(/patch/module/@name,' Patch ', /patch/@patch_id)"/>
	<xsl:with-param name="nr" select="1"/>
	<xsl:with-param name="step_type" select="'MSG'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="logfile" select="$logfile"/>
	<xsl:with-param name="systeminfo_id"  select="/patch/module/@systeminfo_id"/>
	</xsl:call-template>
<!--Masken-->
<xsl:for-each select="/patch/module/patch-data/database/masken/maske">

	<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($job_uniquename,'_mask_',@tid)"/>
	<xsl:with-param name="parent_uniquename" select="$job_uniquename"/>
	<xsl:with-param name="job_uniquename" select="$job_uniquename"/>
	<xsl:with-param name="caption" select="concat($job_uniquename,' Ladeschritt ',' Upload Maske ',@tid)"/>
	<xsl:with-param name="nr" select="1 + position()"/>
	<xsl:with-param name="step_type" select="'4'"/>
	<xsl:with-param name="force_continue" select="'1'"/>
	<xsl:with-param name="logfile" select="$logfile"/>
	<xsl:with-param name="systeminfo_id"  select="/patch/module/@systeminfo_id"/>
	</xsl:call-template>

</xsl:for-each>

<xsl:for-each select="/patch/module/patch-data/upgrade/upgrade-step/action">
<xsl:variable name="nr" select="position()*100" />
<xsl:for-each select="loadtable">

	<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($job_uniquename,'_load_',@tabname)"/>
	<xsl:with-param name="parent_uniquename" select="$job_uniquename"/>
	<xsl:with-param name="job_uniquename" select="$job_uniquename"/>
	<xsl:with-param name="caption" select="concat($job_uniquename,' Ladeschritt ',' Upload Tabelle ',@tabname)"/>
	<xsl:with-param name="nr" select="$nr + (position()*10)"/>
	<xsl:with-param name="step_type" select="'2'"/>
	<xsl:with-param name="force_continue" select="'1'"/>
	<xsl:with-param name="logfile" select="$logfile"/>
	<xsl:with-param name="systeminfo_id"  select="/patch/module/@systeminfo_id"/>
	</xsl:call-template>

</xsl:for-each>

<xsl:for-each select="nativeaction">

	<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($job_uniquename,'_execute_',@scriptfile)"/>
	<xsl:with-param name="parent_uniquename" select="$job_uniquename"/>
	<xsl:with-param name="job_uniquename" select="$job_uniquename"/>
	<xsl:with-param name="caption" select="concat($job_uniquename,' Ladeschritt execute ',@scriptfile)"/>
	<xsl:with-param name="nr" select="$nr + (position()*10)"/>
	<xsl:with-param name="step_type" select="'3'"/>
	<xsl:with-param name="force_continue" select="'1'"/>
	<xsl:with-param name="logfile" select="$logfile"/>
	<xsl:with-param name="systeminfo_id"  select="/patch/module/@systeminfo_id"/>
	</xsl:call-template>

</xsl:for-each>
</xsl:for-each>


<!--Ende Patch-->
</xsl:when>
<xsl:when test="$jobtype='upgrade'">
<xsl:variable name="job_uniquename" select="concat(/module/@name,'_upgrade')" />

<xsl:call-template name="initJob">
<xsl:with-param name="modulkuerzel" select="/module/@name"/>
<xsl:with-param name="uniquename" select="$job_uniquename" />
<xsl:with-param name="caption"  select="concat(/module/@system,' Upgrade')" />
<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
<xsl:with-param name="logfile"  select="concat('L_',/module/@name,'_Upgrade.log')" />
</xsl:call-template>
<xsl:variable name="logfile">
<xsl:value-of select="concat('L_',/module/@name,'_Upgrade.log')"/>
</xsl:variable>

<xsl:text><![CDATA[
<#if '${SQLdialect}'='Postgres' >
 ]]></xsl:text>
 
 
<xsl:call-template name="assign_etl_steps_upgrade">
<xsl:with-param name="job_uniquename" select="$job_uniquename"/>
<xsl:with-param name="database" select="'POSTGRES'"/>
<xsl:with-param name="logfile" select="$logfile"/>
</xsl:call-template>

<xsl:call-template name="assign_etl_step_properties_upgrade">
<xsl:with-param name="job_uniquename" select="$job_uniquename"/>
<xsl:with-param name="database" select="'POSTGRES'"/>
</xsl:call-template>

<xsl:text><![CDATA[
</#if>
 ]]></xsl:text>
 
<xsl:text><![CDATA[
<#if '${SQLdialect}'='Informix' >
 ]]></xsl:text>
<xsl:call-template name="assign_etl_steps_upgrade">
<xsl:with-param name="job_uniquename" select="$job_uniquename"/>
<xsl:with-param name="database" select="'INFORMIX'"/>
<xsl:with-param name="logfile" select="$logfile"/>
</xsl:call-template>
 
<xsl:call-template name="assign_etl_step_properties_upgrade">
<xsl:with-param name="job_uniquename" select="$job_uniquename"/>
<xsl:with-param name="database" select="'INFORMIX'"/>
</xsl:call-template>

<xsl:text><![CDATA[
</#if>
 ]]></xsl:text>
 
</xsl:when>
<xsl:otherwise>
<!--HLR-->
<xsl:variable name="job_uniquename" select="concat(/module/@name,'_main')" />

<xsl:call-template name="initJob">
<xsl:with-param name="modulkuerzel" select="/module/@name"/>
<xsl:with-param name="uniquename" select="$job_uniquename" />
<xsl:with-param name="caption"  select="concat(/module/@system,' Hauptladeroutine')" />
<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
<xsl:with-param name="logfile"  select="concat('L_',/module/@name,'_Update.log')" />
</xsl:call-template>

<xsl:text><![CDATA[
<#if '${SQLdialect}'='Postgres' >
 ]]></xsl:text>

<xsl:call-template name="insertUpdateSteps">
<xsl:with-param name="job_uniquename" select="$job_uniquename"/>
<xsl:with-param name="stepOrProperty" select="'step'"/>
<xsl:with-param name="database" select="'POSTGRES'"/>

</xsl:call-template>
<xsl:call-template name="insertUpdateSteps">
<xsl:with-param name="job_uniquename" select="$job_uniquename"/>
<xsl:with-param name="stepOrProperty" select="'property'"/>
<xsl:with-param name="database" select="'POSTGRES'"/>

</xsl:call-template>

<xsl:text><![CDATA[
</#if>
 ]]></xsl:text>


</xsl:otherwise>
</xsl:choose>
<xsl:text><![CDATA[

<#if etl_step_exists==1>

<@ETL_STEPS_FUELLEN />

</#if>

]]></xsl:text>

</xsl:template>
<xsl:template name="insertStep">
<xsl:param name="uniquename" />
<xsl:param name="parent_uniquename" />
<xsl:param name="job_uniquename" />
<xsl:param name="caption" />
<xsl:param name="nr" />
<xsl:param name="type" />
<xsl:param name="step_type" />
<xsl:param name="force_continue" />
<xsl:param name="logfile"/>
<xsl:param name="systeminfo_id" />
<xsl:param name="isFinal" select="'0'"/>
<xsl:text><![CDATA[
  {"etl_job":"]]></xsl:text><xsl:value-of select="$job_uniquename"/>
<xsl:text>", "uniquename":"</xsl:text><xsl:value-of select="$uniquename"/>
<xsl:text>", "name":"</xsl:text><xsl:value-of select="$caption"/>
<xsl:text>", "type":"</xsl:text><xsl:value-of select="$step_type"/>
<xsl:if test="$parent_uniquename!=''">
<xsl:text>", "parent":"</xsl:text><xsl:value-of select="$parent_uniquename"/>
</xsl:if>
<xsl:text><![CDATA["}]]>
</xsl:text>
<xsl:if test="$isFinal='0'"><xsl:text>,</xsl:text></xsl:if>
<xsl:text>
</xsl:text>
</xsl:template>

<xsl:template name="insertStepProperty">
<xsl:param name="uniquename" />
<xsl:param name="caption" />
<xsl:param name="nr" />
<xsl:param name="step_type" />
<xsl:param name="isFinal"  select="'0'"/>
<xsl:param name="scriptFile"  />
<xsl:param name="sql"  />
<xsl:param name="outfile"  />
<xsl:param name="tabname"  />
<xsl:param name="path_to_inputfile"  />
<xsl:param name="truncateTargetTable"  />
<xsl:param name="format"  />
<xsl:param name="dbconnection"  select="'eduetl'"/><!-- Default-->
<xsl:param name="sqlVarDbconnection"  select="'eduetl'"/>


<!-- Scriptfile argument has higher priority than xml-attribute: -->

<xsl:variable name="scriptFileVar">
<xsl:choose>
<xsl:when test="$scriptFile !=''">
<xsl:value-of select="$scriptFile"/>
</xsl:when>
<xsl:otherwise>
<xsl:value-of select="@scriptfile"/>
</xsl:otherwise>
</xsl:choose>
</xsl:variable>

<xsl:variable name="sqlVar">
<xsl:choose>
<xsl:when test="$sql !=''">
<xsl:variable name="s1">
<xsl:call-template name="search_replace">
  <xsl:with-param name="string" select="$sql" />
  <xsl:with-param name="search" select="$singleQuote" />
  <xsl:with-param name="replace" select="$doubledSingleQuote" />
</xsl:call-template>
</xsl:variable>
<xsl:value-of select="translate($s1,$doubleQuote,$singleQuote)"/>
</xsl:when>
<xsl:otherwise>
<xsl:variable name="s1">
<xsl:call-template name="search_replace">
  <xsl:with-param name="string" select="@sql" />
  <xsl:with-param name="search" select="$singleQuote" />
  <xsl:with-param name="replace" select="$doubledSingleQuote" />
</xsl:call-template>
</xsl:variable>
<xsl:value-of select="translate($s1,';','')"/>
</xsl:otherwise>
</xsl:choose>
</xsl:variable>


<xsl:variable name="tabnameVar">
<xsl:choose>
<xsl:when test="$tabname !=''">
<xsl:value-of select="$tabname"/>
</xsl:when>
<xsl:otherwise>
<xsl:value-of select="@tabname"/>
</xsl:otherwise>
</xsl:choose>
</xsl:variable>

<xsl:variable name="path_to_inputfileVar">
<xsl:choose>
<xsl:when test="$path_to_inputfile !=''">
<xsl:value-of select="$path_to_inputfile"/>
</xsl:when>
<xsl:otherwise>
<xsl:value-of select="file/@path"/>
</xsl:otherwise>
</xsl:choose>
</xsl:variable>


<xsl:variable name="truncateTargetTableVar">
<xsl:choose>
<xsl:when test="$truncateTargetTable !=''">
<xsl:value-of select="$truncateTargetTable"/>
</xsl:when>
<xsl:otherwise>
<xsl:value-of select="@refresh"/>
</xsl:otherwise>
</xsl:choose>
</xsl:variable>

<xsl:variable name="formatVar">
<xsl:choose>
<xsl:when test="$format !=''">
<xsl:value-of select="$format"/>
</xsl:when>
<xsl:otherwise>
<xsl:value-of select="'csv'"/>
</xsl:otherwise>
</xsl:choose>
</xsl:variable>


<xsl:choose>

<xsl:when test="$step_type='MSG'">

<xsl:text><![CDATA[
  {"etl_step":"]]></xsl:text><xsl:value-of select="$uniquename"/>
<xsl:text>", "prop_name":"</xsl:text>
<xsl:text>msg", "prop_value":"</xsl:text>
<xsl:value-of select="$caption"/>
<xsl:text><![CDATA["}
]]>
</xsl:text>
</xsl:when>
<xsl:when test="$step_type='DOQUERY'">

<xsl:text><![CDATA[
  {"etl_step":"]]></xsl:text><xsl:value-of select="$uniquename"/>
<xsl:text>", "prop_name":"</xsl:text>
<xsl:text>select_stmt", "prop_value":"</xsl:text>
<xsl:value-of select="$sqlVar"/>
<xsl:text><![CDATA["}
]]></xsl:text>
<xsl:text><![CDATA[
  {"etl_step":"]]></xsl:text><xsl:value-of select="$uniquename"/>
<xsl:text>", "prop_name":"</xsl:text>
<xsl:text>dbconnection", "prop_value":"</xsl:text>
<xsl:value-of select="$dbconnection"/>
<xsl:text><![CDATA["}
]]></xsl:text>

</xsl:when>
<xsl:when test="$step_type='DOSQL'">
<xsl:text><![CDATA[
  {"etl_step":"]]></xsl:text><xsl:value-of select="$uniquename"/>
<xsl:text>", "prop_name":"</xsl:text>
<xsl:text>dbconnection", "prop_value":"</xsl:text>
<xsl:value-of select="$dbconnection"/>
<xsl:text><![CDATA["}]]></xsl:text>
<xsl:text><![CDATA[
  {"etl_step":"]]></xsl:text><xsl:value-of select="$uniquename"/>
<xsl:text>", "prop_name":"</xsl:text>
<xsl:text>sqlVarDbconnection", "prop_value":"</xsl:text>
<xsl:value-of select="$sqlVarDbconnection"/>
<xsl:text><![CDATA["}]]></xsl:text>
<xsl:text><![CDATA[
  {"etl_step":"]]></xsl:text><xsl:value-of select="$uniquename"/>
<xsl:text>", "prop_name":"PATH_TO_INPUTFILE", "prop_value":"</xsl:text>
<xsl:value-of select="$scriptFileVar"/>
<xsl:text><![CDATA["}]]></xsl:text>
</xsl:when>
<xsl:when test="$step_type='LOAD'">
<xsl:text><![CDATA[
  {"etl_step":"]]></xsl:text><xsl:value-of select="$uniquename"/>
<xsl:text>", "prop_name":"target_table", "prop_value":"</xsl:text>
<xsl:value-of select="$tabnameVar"/>
<xsl:text><![CDATA["},]]></xsl:text>

<xsl:text><![CDATA[
  {"etl_step":"]]></xsl:text><xsl:value-of select="$uniquename"/>
<xsl:text>", "prop_name":"path_to_inputfile", "prop_value":"</xsl:text>
<xsl:value-of select="$path_to_inputfileVar"/><xsl:text><![CDATA["},]]></xsl:text>

<xsl:text><![CDATA[
  {"etl_step":"]]></xsl:text><xsl:value-of select="$uniquename"/>
<xsl:text>", "prop_name":"truncateTargetTable", "prop_value":"</xsl:text>
<xsl:value-of select="$truncateTargetTableVar"/><xsl:text><![CDATA["},]]></xsl:text>

<xsl:text><![CDATA[
  {"etl_step":"]]></xsl:text><xsl:value-of select="$uniquename"/>
<xsl:text>", "prop_name":"format", "prop_value":"</xsl:text>
<xsl:value-of select="$formatVar"/><xsl:text><![CDATA["}]]></xsl:text>




</xsl:when>
<xsl:when test="$step_type='UNLOAD'">
 <xsl:text><![CDATA[
 {"etl_step":"]]></xsl:text><xsl:value-of select="$uniquename"/>
<xsl:text>", "prop_name":"</xsl:text>
<xsl:text>dbconnection", "prop_value":"</xsl:text>
<xsl:value-of select="$dbconnection"/>
<xsl:text><![CDATA["}]]></xsl:text>
<xsl:text><![CDATA[
  {"etl_step":"]]></xsl:text><xsl:value-of select="$uniquename"/>
<xsl:text>", "prop_name":"</xsl:text>
<xsl:text>sqlVarDbconnection", "prop_value":"</xsl:text>
<xsl:value-of select="$sqlVarDbconnection"/>
<xsl:text><![CDATA["}]]></xsl:text>
<xsl:text><![CDATA[
  {"etl_step":"]]></xsl:text><xsl:value-of select="$uniquename"/>
<xsl:text>", "prop_name":"select_stmt", "prop_value":"</xsl:text>
<xsl:value-of select="$sqlVar"/>
<xsl:text><![CDATA["},]]></xsl:text>

<xsl:text><![CDATA[
  {"etl_step":"]]></xsl:text><xsl:value-of select="$uniquename"/>
<xsl:text>", "prop_name":"outfile", "prop_value":"</xsl:text>
<xsl:value-of select="$outfile"/><xsl:text><![CDATA["},]]></xsl:text>

<xsl:text><![CDATA[
  {"etl_step":"]]></xsl:text><xsl:value-of select="$uniquename"/>
<xsl:text>", "prop_name":"format", "prop_value":"</xsl:text>
<xsl:value-of select="$formatVar"/><xsl:text><![CDATA["}]]></xsl:text>




</xsl:when>
<xsl:otherwise>
</xsl:otherwise>
</xsl:choose>
<xsl:if test="$isFinal='0'"><xsl:text>,</xsl:text></xsl:if>
<xsl:text>
</xsl:text>

</xsl:template>

<xsl:template name="initJob">
<xsl:param name="modulkuerzel" />
<xsl:param name="uniquename" />
<xsl:param name="jobtype" />
<xsl:param name="caption" />
<xsl:param name="systeminfo_id" />
<xsl:param name="logfile" />
<xsl:text><![CDATA[<#assign  etl_jobs = [
  {"uniquename":"]]></xsl:text><xsl:value-of select="$uniquename"/>
  <xsl:text><![CDATA[", "name":"]]></xsl:text><xsl:value-of select="$caption"/>
  <xsl:text><![CDATA[", "systeminfo_id":]]></xsl:text><xsl:value-of select="$systeminfo_id"/>
  <xsl:text><![CDATA[,"logfile":"]]></xsl:text><xsl:value-of select="$logfile"/>
  <xsl:text><![CDATA["}
 
  ] />
<#assign  etl_job_params = [
  {"etl_job":"]]></xsl:text><xsl:value-of select="$uniquename"/>
  <xsl:text>","param_name":"</xsl:text>
 <xsl:call-template name="ucase">
<xsl:with-param name="s1" select="$modulkuerzel" />
</xsl:call-template>
<xsl:text><![CDATA[_PFAD", "name":"Modulpfad", "param_default":""},
  {"etl_job":"]]></xsl:text><xsl:value-of select="$uniquename"/>
  <xsl:text>","param_name":"</xsl:text>
 <xsl:call-template name="ucase">
<xsl:with-param name="s1" select="$modulkuerzel" />
</xsl:call-template>
<xsl:text><![CDATA[_LOAD_PFAD", "name":"Pfad für Rohdaten des Moduls", "param_default":""}
 
  ] /> 
]]>
</xsl:text>

</xsl:template>
<xsl:template name="get_typ_str">
<xsl:choose>
<xsl:when test="@type='load'">
<xsl:text>Load</xsl:text>
</xsl:when>
<xsl:when test="@type='trans'">
<xsl:text>Transformation</xsl:text>
</xsl:when>
<xsl:when test="@type='aggr'">
<xsl:text>Aggregation</xsl:text>
</xsl:when>
<xsl:when test="@type='test'">
<xsl:text>Test</xsl:text>
</xsl:when>
<xsl:when test="@type='system'">
<xsl:text>Standdatum</xsl:text>
</xsl:when>
<xsl:otherwise>
<xsl:value-of select="@type" />
</xsl:otherwise>
</xsl:choose>
</xsl:template>
<xsl:template name="ucase">
<xsl:param name="s1"/>
<xsl:value-of select="translate($s1,'abcdefghijklmnopqrstuvwxyz ','ABCDEFGHIJKLMNOPQRSTUVWXYZ_')" />
</xsl:template>

<xsl:template name="get_nv_step_type" >
	<xsl:choose>
	<xsl:when test="@scriptfile!=''">
		<xsl:text>DOSQL</xsl:text>
		
	</xsl:when>
	<xsl:otherwise>
		<xsl:text>DOQUERY</xsl:text>
	</xsl:otherwise>
	</xsl:choose>

</xsl:template>

<xsl:template name="get_nv_caption" >
<xsl:param name="typ" />
<xsl:param name="nr" />
	<xsl:choose>
	<xsl:when test="@scriptfile!=''">
		<xsl:value-of select="concat(/module/@name,' Ladeschritt ',$typ,' Execute ',@scriptfile)"/>
	</xsl:when>
	<xsl:otherwise>
		<xsl:value-of select="concat(/module/@name,' Ladeschritt ',$typ,' Execute ',$nr)"/>
	</xsl:otherwise>
	</xsl:choose>

</xsl:template>

<xsl:template name="get_nv_uniquename" >
<xsl:param name="typ" />
<xsl:param name="nr" />
	<xsl:choose>
	<xsl:when test="@scriptfile!=''">
		<xsl:value-of select="concat(/module/@name,'_', $typ,'_',@scriptfile)"/>
	</xsl:when>
	<xsl:when test="@sql!=''">
	<xsl:variable name="sql1">
<xsl:call-template name="search_replace">
  <xsl:with-param name="string" select="translate(@sql,';','')" />
  <xsl:with-param name="search" select="'('"/>
<xsl:with-param name="replace" select="''"/>
</xsl:call-template>
</xsl:variable>
	<xsl:variable name="sql2">
<xsl:call-template name="search_replace">
  <xsl:with-param name="string" select="translate($sql1,$singleQuote,' ')" />
  <xsl:with-param name="search" select="')'"/>
<xsl:with-param name="replace" select="''"/>
</xsl:call-template>
</xsl:variable>
<xsl:value-of select="substring($sql2,1,255)"/>
	
	</xsl:when>
	<xsl:otherwise>
		<xsl:value-of select="concat(/module/@name,'_',$typ,'_',$nr)"/>
	</xsl:otherwise>
	</xsl:choose>

</xsl:template>

<xsl:template name="assign_etl_steps_upgrade">
<xsl:param name="job_uniquename" select="''"/>
<xsl:param name="database" select="'POSTGRES'"/>
<xsl:param name="logfile" select="''"/>
<xsl:text><![CDATA[
<#assign  etl_steps = [
]]></xsl:text>

	<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="$job_uniquename"/>
	<xsl:with-param name="parent_uniquename" select="''"/>
	<xsl:with-param name="job_uniquename" select="$job_uniquename"/>
	<xsl:with-param name="caption" select="concat('Upgrade ',/module/@system)"/>
	<xsl:with-param name="nr" select="1"/>
	<xsl:with-param name="step_type" select="'MSG'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="logfile" select="$logfile"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>
	</xsl:call-template>

<xsl:call-template name="insertInstallUpgradeSteps">
<xsl:with-param name="parentUniquename" select="$job_uniquename"/>
<xsl:with-param name="installOrUpgrade" select="'upgrade'"/>
<xsl:with-param name="stepOrProperty" select="'step'"/>
<xsl:with-param name="database" select="$database"/>

</xsl:call-template>

<xsl:for-each select="/module/upgrade/upgrade-step">
<xsl:variable name="nr" select="position()*1000" />

<xsl:call-template name="insertActionStepProperties">
<xsl:with-param name="jobUniquename" select="$job_uniquename"/>
<xsl:with-param name="parentUniquename" select="$job_uniquename"/>
<xsl:with-param name="installOrUpgrade" select="'upgrade'"/>
<xsl:with-param name="stepOrProperty" select="'step'"/>
<xsl:with-param name="logfile" select="$logfile"/>
<xsl:with-param name="database" select="$database"/>

</xsl:call-template>
</xsl:for-each><!--Ende etl_step Schleife-->
	<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat(/module/@name,'_Upgrade_finish')"/>
	<xsl:with-param name="caption" select="concat('Ende Upgrade ',/module/@system)"/>
	<xsl:with-param name="parent_uniquename" select="''"/>
	<xsl:with-param name="job_uniquename" select="$job_uniquename"/>
	<xsl:with-param name="nr" select="0"/>
	<xsl:with-param name="step_type" select="'MSG'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="logfile" select="''"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'1'"/>
	</xsl:call-template>
<xsl:text><![CDATA[
 ] />

 ]]></xsl:text>
</xsl:template>

<xsl:template name="assign_etl_step_properties_upgrade">
<xsl:param name="job_uniquename" select="''"/>
<xsl:param name="database" select="'POSTGRES'"/>
<xsl:text><![CDATA[
<#assign  etl_step_properties = [

 
]]></xsl:text>

<xsl:for-each select="/module/upgrade/upgrade-step">
<xsl:variable name="nr" select="position()*1000" />

<xsl:variable name="logfile">
<xsl:value-of select="concat('L_',/module/@name,'_Upgrade.log')"/>
</xsl:variable>

<xsl:call-template name="insertStepProperty">
	<xsl:with-param name="uniquename" select="concat(/module/@name,'_upgrade')"/>
	<xsl:with-param name="caption" select="concat('Upgrade ',/module/@system)"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'MSG'"/>
	<xsl:with-param name="isFinal"  select="'0'"/>
</xsl:call-template>

<xsl:call-template name="insertInstallUpgradeSteps">
<xsl:with-param name="parentUniquename" select="$job_uniquename"/>
<xsl:with-param name="installOrUpgrade" select="'upgrade'"/>
<xsl:with-param name="stepOrProperty" select="'property'"/>
<xsl:with-param name="database" select="$database"/>

</xsl:call-template>

<xsl:call-template name="insertActionStepProperties">
<xsl:with-param name="jobUniquename" select="$job_uniquename"/>
<xsl:with-param name="parentUniquename" select="$job_uniquename"/>
<xsl:with-param name="installOrUpgrade" select="'upgrade'"/>
<xsl:with-param name="stepOrProperty" select="'property'"/>
<xsl:with-param name="logfile" select="$logfile"/>
<xsl:with-param name="database" select="$database"/>
</xsl:call-template>


</xsl:for-each>

<xsl:call-template name="insertStepProperty">
	<xsl:with-param name="uniquename" select="concat(/module/@name,'_Upgrade_finish')"/>
	<xsl:with-param name="caption" select="concat('Ende Upgrade ',/module/@system)"/>
	<xsl:with-param name="nr" select="1"/>
	<xsl:with-param name="step_type" select="'MSG'"/>
	<xsl:with-param name="isFinal"  select="'1'"/>
</xsl:call-template>

<xsl:text><![CDATA[
  ] />

]]></xsl:text>
</xsl:template>

<xsl:template name="insertUpdateSteps">
<xsl:param name="job_uniquename" select="''"/>
<xsl:param name="stepOrProperty" select="'step'"/>
<xsl:param name="database" select="'POSTGRES'"/>
<xsl:choose>
<xsl:when test="$stepOrProperty='step'"> 

<xsl:text><![CDATA[
<#assign  etl_steps = [
]]></xsl:text>


<xsl:for-each select="/module/etl/etl-step [@type != 'manual']">
<xsl:variable name="nr" select="position()*1000" />
<xsl:variable name="typ"><xsl:value-of select="@type" /></xsl:variable>
<xsl:variable name="typ_str"><xsl:call-template name="get_typ_str" />
</xsl:variable>
<xsl:variable name="logfile">
<xsl:value-of select="concat('L_',/module/@name,'_',$typ_str,'.log')"/>
</xsl:variable>

	<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat(/module/@name,'_',@type)"/>
	<xsl:with-param name="parent_uniquename" select="''"/>
	<xsl:with-param name="job_uniquename" select="$job_uniquename"/>
	<xsl:with-param name="caption" select="concat('Hauptladeroutine ',/module/@system,' Ladeschritt ',@type)"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'MSG'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="logfile" select="$logfile"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>
	</xsl:call-template>
	
	
<xsl:for-each select="action">

<xsl:for-each select="loadtable">
<xsl:variable name="nr" select="$nr + (position()*100)" />

	<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat(/module/@name,'_load_',@tabname)"/>
	<xsl:with-param name="parent_uniquename" select="concat(/module/@name,'_',$typ)"/>
	<xsl:with-param name="job_uniquename" select="$job_uniquename"/>
	<xsl:with-param name="caption" select="concat(/module/@name,' Ladeschritt ',$typ,' Upload Tabelle ',@tabname)"/>
	<xsl:with-param name="nr" select="$nr + (position()*10)"/>
	<xsl:with-param name="step_type" select="'LOAD'"/>
	<xsl:with-param name="force_continue" select="'1'"/>
	<xsl:with-param name="logfile" select="concat(/module/@name,'_',$typ,'.log')"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	</xsl:call-template>


</xsl:for-each>


<xsl:for-each select="nativeaction[@database=$database or @database='']">
<xsl:variable name="nr" select="$nr + (position()*100)" />
<xsl:variable name="nv_uniquename" >
	<xsl:call-template name="get_nv_uniquename" >
		<xsl:with-param name="typ" select="$typ" />
		<xsl:with-param name="nr" select="$nr" />
	</xsl:call-template>
</xsl:variable>
<xsl:variable name="nv_caption" >
	<xsl:call-template name="get_nv_caption" >
		<xsl:with-param name="typ" select="$typ" />
		<xsl:with-param name="nr" select="$nr" />
	</xsl:call-template>
</xsl:variable>
<xsl:variable name="nv_step_type" >
	<xsl:call-template name="get_nv_step_type" />
</xsl:variable>
	<xsl:call-template name="insertStep">
		<xsl:with-param name="uniquename" select="$nv_uniquename"/>
		<xsl:with-param name="parent_uniquename" select="concat(/module/@name,'_',$typ)"/>
		<xsl:with-param name="job_uniquename" select="$job_uniquename"/>
		<xsl:with-param name="caption"  select="$nv_caption"/>
		<xsl:with-param name="nr" select="$nr + (position()*10)"/>
		<xsl:with-param name="step_type" select="$nv_step_type"/>
		<xsl:with-param name="force_continue" select="'1'"/>
		<xsl:with-param name="logfile" select="''"/>
		<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	</xsl:call-template>

</xsl:for-each>
</xsl:for-each>
</xsl:for-each><!--Ende etl_step Schleife-->
	<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat(/module/@name,'_HRL_finish')"/>
	<xsl:with-param name="caption" select="concat('Ende Hauptladeroutine ',/module/@system)"/>
	<xsl:with-param name="parent_uniquename" select="''"/>
	<xsl:with-param name="job_uniquename" select="$job_uniquename"/>
	<xsl:with-param name="nr" select="0"/>
	<xsl:with-param name="step_type" select="'MSG'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="logfile" select="''"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'1'"/>
	</xsl:call-template>
<xsl:text><![CDATA[
 ] />

]]></xsl:text>
</xsl:when>
<xsl:otherwise>
<!--property-->
<xsl:text><![CDATA[

<#assign  etl_step_properties = [

 
]]></xsl:text>

<xsl:for-each select="/module/etl/etl-step [@type != 'manual']">
<xsl:variable name="nr" select="position()*1000" />
<xsl:variable name="typ"><xsl:value-of select="@type" /></xsl:variable>
<xsl:variable name="typ_str"><xsl:call-template name="get_typ_str" />
</xsl:variable>
<xsl:variable name="logfile">
<xsl:value-of select="concat('L_',/module/@name,'_',$typ_str,'.log')"/>
</xsl:variable>

<xsl:call-template name="insertStepProperty">
	<xsl:with-param name="uniquename" select="concat(/module/@name,'_',@type)"/>
	<xsl:with-param name="caption" select="concat('Hauptladeroutine ',/module/@system,' Ladeschritt ',@type)"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'MSG'"/>
	<xsl:with-param name="isFinal"  select="'0'"/>
</xsl:call-template>

<xsl:for-each select="action">

<xsl:for-each select="nativeaction[@database=$database or @database='']">
<xsl:variable name="nr" select="$nr + (position()*100)" />
<xsl:variable name="nv_uniquename" >
	<xsl:call-template name="get_nv_uniquename" >
		<xsl:with-param name="typ" select="$typ" />
		<xsl:with-param name="nr" select="$nr" />
	</xsl:call-template>
</xsl:variable>
<xsl:variable name="nv_caption" >
	<xsl:call-template name="get_nv_caption" >
		<xsl:with-param name="typ" select="$typ" />
		<xsl:with-param name="nr" select="$nr" />
	</xsl:call-template>
</xsl:variable>
<xsl:variable name="nv_step_type" >
	<xsl:call-template name="get_nv_step_type" />
</xsl:variable>
	<xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="$nv_uniquename"/>
		<xsl:with-param name="caption" select="$nv_caption"/>
		<xsl:with-param name="nr" select="$nr + (position()*10)"/>
		<xsl:with-param name="step_type" select="$nv_step_type"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
	</xsl:call-template>

</xsl:for-each>

<xsl:for-each select="loadtable">
<xsl:variable name="nr" select="$nr + (position()*100)" />

<xsl:call-template name="insertStepProperty">
	<xsl:with-param name="uniquename" select="concat(/module/@name,'_load_',@tabname)"/>
	<xsl:with-param name="caption" select="concat('Lade Tabelle ',@tabname)"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'LOAD'"/>
	<xsl:with-param name="isFinal"  select="'0'"/>
</xsl:call-template>
</xsl:for-each>



</xsl:for-each>

</xsl:for-each>

<xsl:call-template name="insertStepProperty">
	<xsl:with-param name="uniquename" select="concat(/module/@name,'_HRL_finish')"/>
	<xsl:with-param name="caption" select="concat('Ende Hauptladeroutine ',/module/@system)"/>
	<xsl:with-param name="nr" select="1"/>
	<xsl:with-param name="step_type" select="'MSG'"/>
	<xsl:with-param name="isFinal"  select="'1'"/>
</xsl:call-template>

<xsl:text><![CDATA[
  ] />

]]></xsl:text>
</xsl:otherwise>
</xsl:choose>
</xsl:template>


<xsl:template name="insertInstallUpgradeSteps">
<xsl:param name="parentUniquename" select="''"/>
<xsl:param name="installOrUpgrade" select="''"/>
<xsl:param name="stepOrProperty" select="'step'"/>
<xsl:param name="nr" />

<xsl:variable name="modulpfad"><xsl:text>$</xsl:text>
<xsl:call-template name="ucase">
<xsl:with-param name="s1" select="/module/@name" />
</xsl:call-template>
<xsl:text>_PFAD</xsl:text>
</xsl:variable>
<!--zuerst upgrade_tables -->


<xsl:if test="$stepOrProperty='step'"> 
<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_tables')"/>
	<xsl:with-param name="parent_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="job_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="caption" select="'Tabellen anlegen, falls noch nicht vorhanden'"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'DOSQL'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>
	</xsl:call-template>
</xsl:if>
<xsl:if test="$stepOrProperty='property'"> 

	<xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_tables')"/>
		<xsl:with-param name="caption" select="'Scriptfile'"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'DOSQL'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="scriptFile"  select="concat($modulpfad,'/',$installOrUpgrade,'/',/module/@name,'_upgrade_tables_pg.sql')"/><!--TODO:pg or ids-->
	</xsl:call-template>
</xsl:if>
<!--dann upgrade_fields -->

<xsl:if test="$stepOrProperty='step'"> 
<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_fields')"/>
	<xsl:with-param name="parent_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="job_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="caption" select="'Felder anlegen, falls noch nicht vorhanden'"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'DOSQL'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>
	</xsl:call-template>
</xsl:if>
<xsl:if test="$stepOrProperty='property'"> 

	<xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_fields')"/>
		<xsl:with-param name="caption" select="'Scriptfile'"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'DOSQL'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="scriptFile"  select="concat($modulpfad,'/',$installOrUpgrade,'/',/module/@name,'_upgrade_fields_pg.sql')"/><!--TODO:pg or ids-->
	</xsl:call-template>
</xsl:if>

<!--dann upgrade_views -->

<xsl:if test="$stepOrProperty='step'"> 
<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_views')"/>
	<xsl:with-param name="parent_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="job_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="caption" select="'Views anlegen, falls noch nicht vorhanden'"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'DOSQL'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>
	</xsl:call-template>
</xsl:if>
<xsl:if test="$stepOrProperty='property'"> 

	<xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_views')"/>
		<xsl:with-param name="caption" select="'Scriptfile'"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'DOSQL'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="scriptFile"  select="concat($modulpfad,'/',$installOrUpgrade,'/',/module/@name,'_upgrade_views_pg.sql')"/><!--TODO:pg or ids-->
	</xsl:call-template>
</xsl:if>

<!--dann upgrade_functions -->

<xsl:if test="$stepOrProperty='step'"> 
<xsl:for-each select="/module/database/functions/function">
<xsl:choose>
<xsl:when test="count(src[dbsystem='POSTGRES']/file) &gt; 0">
<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_function_',name)"/>
	<xsl:with-param name="parent_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="job_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="caption" select="concat('Function ',name,' anlegen, falls noch nicht vorhanden')"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'DOSQL'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>
	</xsl:call-template>
</xsl:when>
<xsl:when test="count(src[dbsystem='POSTGRES']/body) &gt; 0">
<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_function_',name)"/>
	<xsl:with-param name="parent_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="job_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="caption" select="concat('Function ',name,' anlegen, falls noch nicht vorhanden')"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'DOQUERY'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>
	</xsl:call-template>
</xsl:when>
<xsl:otherwise>
<!--do nothing-->
</xsl:otherwise>
</xsl:choose>
</xsl:for-each>
</xsl:if>
<xsl:if test="$stepOrProperty='property'"> 
<xsl:for-each select="/module/database/functions/function">
<xsl:choose>
<xsl:when test="count(src[dbsystem='POSTGRES']/file) &gt; 0">

	<xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_function_',name)"/>
		<xsl:with-param name="caption" select="'Scriptfile'"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'DOSQL'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="scriptFile"  select="src[dbsystem='POSTGRES']/file"/><!--TODO:pg or ids-->
	</xsl:call-template>
</xsl:when>
<xsl:when test="count(src[dbsystem='POSTGRES']/body) &gt; 0">
	<xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_function_',name)"/>
		<xsl:with-param name="caption" select="'SQL'"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'DOQUERY'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="sql" select="src[dbsystem='POSTGRES']/body"/><!--TODO:pg or ids-->
	</xsl:call-template>

</xsl:when>
<xsl:otherwise>
<!--do nothing-->
</xsl:otherwise>
</xsl:choose>

</xsl:for-each>
</xsl:if>

<!--dann upgrade_indexes -->

<xsl:if test="$stepOrProperty='step'"> 
<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_indexes')"/>
	<xsl:with-param name="parent_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="job_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="caption" select="'Indexes anlegen, falls noch nicht vorhanden'"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'DOSQL'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>
	</xsl:call-template>
</xsl:if>
<xsl:if test="$stepOrProperty='property'"> 

	<xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_indexes')"/>
		<xsl:with-param name="caption" select="'Scriptfile'"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'DOSQL'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="scriptFile"  select="concat($modulpfad,'/',$installOrUpgrade,'/',/module/@name,'_upgrade_indexes_pg.sql')"/><!--TODO:pg or ids-->
	</xsl:call-template>
</xsl:if>
<!--dann sx_tables_fuellen.sql -->

<xsl:if test="$stepOrProperty='step'"> 
<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_sx_tables')"/>
	<xsl:with-param name="parent_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="job_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="caption" select="'sx_tables_-Einträge anlegen, falls noch nicht vorhanden'"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'DOSQL'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>
	</xsl:call-template>
</xsl:if>
<xsl:if test="$stepOrProperty='property'"> 

	<xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_sx_tables')"/>
		<xsl:with-param name="caption" select="'Scriptfile'"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'DOSQL'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="scriptFile"  select="concat($modulpfad,'/conf/sx_tables_fuellen.sql')"/>
	</xsl:call-template>
</xsl:if>

<!--dann sx_fields_fuellen.sql -->

<xsl:if test="$stepOrProperty='step'"> 
<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_sx_fields')"/>
	<xsl:with-param name="parent_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="job_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="caption" select="'sx_fields_-Einträge anlegen, falls noch nicht vorhanden'"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'DOSQL'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>
	</xsl:call-template>
</xsl:if>
<xsl:if test="$stepOrProperty='property'"> 

	<xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_sx_fields')"/>
		<xsl:with-param name="caption" select="'Scriptfile'"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'DOSQL'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="scriptFile"  select="concat($modulpfad,'/conf/sx_fields_fuellen.sql')"/>
	</xsl:call-template>
</xsl:if>


<!--dann unload_params -->

<xsl:if test="$stepOrProperty='step'"> 
<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_unload_params')"/>
	<xsl:with-param name="parent_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="job_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="caption" select="'unload_params-Einträge anlegen, falls noch nicht vorhanden'"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'DOSQL'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>
	</xsl:call-template>
</xsl:if>
<xsl:if test="$stepOrProperty='property'"> 

	<xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_unload_params')"/>
		<xsl:with-param name="caption" select="'Scriptfile'"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'DOSQL'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="scriptFile"  select="concat($modulpfad,'/conf/unload_params_fuellen.sql')"/>
	</xsl:call-template>
</xsl:if>

<!-- metadata -->


<xsl:if test="$stepOrProperty='step'"> 
<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_metadata')"/>
	<xsl:with-param name="parent_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="job_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="caption" select="'metadata(db_forms,sachgebiete et.) Einträge anlegen, falls noch nicht vorhanden'"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'DOSQL'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>
	</xsl:call-template>
</xsl:if>
<xsl:if test="$stepOrProperty='property'"> 

	<xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_metadata')"/>
		<xsl:with-param name="caption" select="'Scriptfile'"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'DOSQL'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="scriptFile"  select="concat($modulpfad,'/conf/module_metadata.sql')"/>
	</xsl:call-template>
</xsl:if>
<!--dann upgrade_themenbaum -->

<xsl:if test="$stepOrProperty='step'"> 
<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_themenbaum')"/>
	<xsl:with-param name="parent_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="job_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="caption" select="'Themenbaum-Einträge anlegen, falls noch nicht vorhanden'"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'DOSQL'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>
	</xsl:call-template>
</xsl:if>
<xsl:if test="$stepOrProperty='property'"> 

	<xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_themenbaum')"/>
		<xsl:with-param name="caption" select="'Scriptfile'"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'DOSQL'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="scriptFile"  select="concat($modulpfad,'/',$installOrUpgrade,'/',/module/@name,'_upgrade_themenbaum.sql')"/><!--TODO:pg or ids-->
	</xsl:call-template>
</xsl:if>
<!-- nun die masken -->
<xsl:for-each select="/module/database/masken/maske">
<!--
 {"etl_job":"sx_insert_mask","param_name":"TID", "name":"Maskennr.", "param_default":""},
  {"etl_job":"sx_insert_mask","param_name":"PATH_TO_INPUTFILE", "name":"Eingabepfad", "param_default":"$SUPERX_DIR/db/masken/$TID.xml"},
  {"etl_job":"sx_insert_mask","param_name":"FORMAT", "name":"Format", "param_default":"XML"},
-->
<xsl:if test="$stepOrProperty='step'"> 
<!-- zuerst delete -->
<!--maskeninfo-->
<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_maskeninfo_delete_',@tid)"/>
	<xsl:with-param name="parent_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="job_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="caption" select="concat('Maske ',@tid,' löschen, falls vorhanden')"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'DOQUERY'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>

	</xsl:call-template>
<!--felderinfo-->
<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_felderinfo_delete_',@tid)"/>
	<xsl:with-param name="parent_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="job_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="caption" select="concat('Maskenfelder ',@tid,' löschen, falls vorhanden')"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'DOQUERY'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>

	</xsl:call-template>
	<!--masken_felder_bez-->
<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_masken_felder_bez_delete_',@tid)"/>
	<xsl:with-param name="parent_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="job_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="caption" select="concat('Maskenfelder ',@tid,' löschen, falls vorhanden')"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'DOQUERY'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>

	</xsl:call-template>
	<!--sachgeb_maske_bez-->
<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_sachgeb_maske_bez_delete_',@tid)"/>
	<xsl:with-param name="parent_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="job_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="caption" select="concat('sachgeb_maske_bez Maske ',@tid,' löschen, falls vorhanden')"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'DOQUERY'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>

	</xsl:call-template>
	<!--maske_system_bez-->
<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_maske_system_bez_delete_',@tid)"/>
	<xsl:with-param name="parent_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="job_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="caption" select="concat('maske_system_bez Maske ',@tid,' löschen, falls vorhanden')"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'DOQUERY'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>

	</xsl:call-template>	
	
<!--jetzt load-->
	<!--maskeninfo_load-->
<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_maskeninfo_load_',@tid)"/>
	<xsl:with-param name="parent_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="job_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="caption" select="concat('Maskeninfo ',@tid,' hochladen')"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'LOAD'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>

	</xsl:call-template>
	<!--felderinfo_load-->
<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_felderinfo_load_',@tid)"/>
	<xsl:with-param name="parent_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="job_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="caption" select="concat('Felder von Maskeninfo ',@tid,' hochladen')"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'LOAD'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>

	</xsl:call-template>
	<!--masken_felder_bez_load-->
<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_masken_felder_bez_load_',@tid)"/>
	<xsl:with-param name="parent_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="job_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="caption" select="concat('masken_felder_bez Maskeninfo ',@tid,' hochladen')"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'LOAD'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>

	</xsl:call-template>
	<!--sachgeb_maske_bez_load-->
<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_sachgeb_maske_bez_load_',@tid)"/>
	<xsl:with-param name="parent_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="job_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="caption" select="concat('sachgeb_maske_bez Maskeninfo ',@tid,' hochladen')"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'LOAD'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>

	</xsl:call-template>
	<!--maske_system_bez_load-->
<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_maske_system_bez_load_',@tid)"/>
	<xsl:with-param name="parent_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="job_uniquename" select="$parentUniquename"/>
	<xsl:with-param name="caption" select="concat('maske_system_bez Maskeninfo ',@tid,' hochladen')"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'LOAD'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>

	</xsl:call-template>

</xsl:if>
<xsl:if test="$stepOrProperty='property'"> 
<!-- zuerst delete -->
  <xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_maskeninfo_delete_',@tid)"/>
		<xsl:with-param name="caption" select="concat('maskeninfo ',@name)"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'DOQUERY'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="sql" select="concat('delete from maskeninfo where tid=',@tid)"/>
	</xsl:call-template>
 <xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_felderinfo_delete_',@tid)"/>
		<xsl:with-param name="caption" select="concat('felderinfo ',@name)"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'DOQUERY'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="sql" select="concat('delete from felderinfo where tid in  (select felderinfo_id from masken_felder_bez where maskeninfo_id =',@tid,')')"/>
	</xsl:call-template>
 <xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_masken_felder_bez_delete_',@tid)"/>
		<xsl:with-param name="caption" select="concat('masken_felder_bez ',@name)"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'DOQUERY'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="sql" select="concat('delete from masken_felder_bez where maskeninfo_id =',@tid)"/>
	</xsl:call-template>
 <xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_sachgeb_maske_bez_delete_',@tid)"/>
		<xsl:with-param name="caption" select="concat('sachgeb_maske_bez ',@name)"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'DOQUERY'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="sql" select="concat('delete from sachgeb_maske_bez where maskeninfo_id=',@tid)"/>
	</xsl:call-template>
 <xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_maske_system_bez_delete_',@tid)"/>
		<xsl:with-param name="caption" select="concat('maske_system_bez ',@name)"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'DOQUERY'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="sql" select="concat('delete from maske_system_bez where maskeninfo_id=',@tid)"/>
	</xsl:call-template>

	
	
<!-- dann load -->
  <xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_maskeninfo_load_',@tid)"/>
		<xsl:with-param name="caption" select="concat('Maske ',@name,' hochladen')"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'LOAD'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="tabname" select="'maskeninfo'"/>
		<xsl:with-param name="path_to_inputfile" select="concat($modulpfad,'/masken/',@tid,'_maskeninfo.unl')"/>
		<xsl:with-param name="truncateTargetTable" select="'false'"/>
		<xsl:with-param name="format" select="'csv'"/>
	</xsl:call-template>
  <xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_felderinfo_load_',@tid)"/>
		<xsl:with-param name="caption" select="concat('felderinfo Maske ',@name,' hochladen')"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'LOAD'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="tabname" select="'felderinfo'"/>
		<xsl:with-param name="path_to_inputfile" select="concat($modulpfad,'/masken/',@tid,'_felderinfo.unl')"/>
		<xsl:with-param name="truncateTargetTable" select="'false'"/>
		<xsl:with-param name="format" select="'csv'"/>
	</xsl:call-template>
  <xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_masken_felder_bez_load_',@tid)"/>
		<xsl:with-param name="caption" select="concat('masken_felder_bez Maske ',@name,' hochladen')"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'LOAD'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="tabname" select="'masken_felder_bez'"/>
		<xsl:with-param name="path_to_inputfile" select="concat($modulpfad,'/masken/',@tid,'_masken_felder_bez.unl')"/>
		<xsl:with-param name="truncateTargetTable" select="'false'"/>
		<xsl:with-param name="format" select="'csv'"/>
	</xsl:call-template>
  <xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_sachgeb_maske_bez_load_',@tid)"/>
		<xsl:with-param name="caption" select="concat('sachgeb_maske_bez Maske ',@name,' hochladen')"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'LOAD'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="tabname" select="'sachgeb_maske_bez'"/>
		<xsl:with-param name="path_to_inputfile" select="concat($modulpfad,'/masken/',@tid,'_sachgeb_maske_bez.unl')"/>
		<xsl:with-param name="truncateTargetTable" select="'false'"/>
		<xsl:with-param name="format" select="'csv'"/>
	</xsl:call-template>
  <xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="concat($parentUniquename,'_',$installOrUpgrade,'_maske_system_bez_load_',@tid)"/>
		<xsl:with-param name="caption" select="concat('maske_system_bez Maske ',@name,' hochladen')"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'LOAD'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="tabname" select="'maske_system_bez'"/>
		<xsl:with-param name="path_to_inputfile" select="concat($modulpfad,'/masken/',@tid,'_maske_system_bez.unl')"/>
		<xsl:with-param name="truncateTargetTable" select="'false'"/>
		<xsl:with-param name="format" select="'csv'"/>
	</xsl:call-template>
 
 

</xsl:if>

</xsl:for-each>

</xsl:template>

<xsl:template name="insertActionStepProperties">
<xsl:param name="job_uniquename" select="''"/>
<xsl:param name="parentUniquename" select="''"/>
<xsl:param name="installOrUpgrade" select="''"/>
<xsl:param name="stepOrProperty" select="'property'"/>
<xsl:param name="logfile" select="''"/>
<xsl:param name="nr" />
<xsl:param name="database" select="'POSTGRES'"/>
<xsl:choose>
<xsl:when test="$stepOrProperty='step'">
<xsl:for-each select="action">
<xsl:variable name="nr" select="$nr + (position()*100)" />

<xsl:for-each select="loadtable">
<xsl:variable name="nr" select="$nr + (position()*100)" />

	<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat(/module/@name,'_',$installOrUpgrade,'_load_',@tabname)"/>
	<xsl:with-param name="parent_uniquename" select="concat(/module/@name,'_',$installOrUpgrade)"/>
	<xsl:with-param name="job_uniquename" select="$job_uniquename"/>
	<xsl:with-param name="caption" select="concat(/module/@name,' Ladeschritt Upload Tabelle ',@tabname)"/>
	<xsl:with-param name="nr" select="$nr + (position()*10)"/>
	<xsl:with-param name="step_type" select="'LOAD'"/>
	<xsl:with-param name="force_continue" select="'1'"/>
	<xsl:with-param name="logfile" select="$logfile"/>
	<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	</xsl:call-template>


</xsl:for-each>


<xsl:for-each select="nativeaction[@database=$database or @database='']">
<xsl:variable name="nr" select="$nr + (position()*100)" />
<xsl:variable name="nv_uniquename" >
	<xsl:call-template name="get_nv_uniquename" >
		<xsl:with-param name="typ" select="$installOrUpgrade" />
		<xsl:with-param name="nr" select="$nr" />
	</xsl:call-template>
</xsl:variable>
<xsl:variable name="nv_caption" >
	<xsl:call-template name="get_nv_caption" >
		<xsl:with-param name="typ" select="$installOrUpgrade" />
		<xsl:with-param name="nr" select="$nr" />
	</xsl:call-template>
</xsl:variable>
<xsl:variable name="nv_step_type" >
	<xsl:call-template name="get_nv_step_type" />
</xsl:variable>
	<xsl:call-template name="insertStep">
		<xsl:with-param name="uniquename" select="$nv_uniquename"/>
		<xsl:with-param name="parent_uniquename" select="concat(/module/@name,'_',$installOrUpgrade)"/>
		<xsl:with-param name="job_uniquename" select="$job_uniquename"/>
		<xsl:with-param name="caption"  select="$nv_caption"/>
		<xsl:with-param name="nr" select="$nr + (position()*10)"/>
		<xsl:with-param name="step_type" select="$nv_step_type"/>
		<xsl:with-param name="force_continue" select="'1'"/>
		<xsl:with-param name="logfile" select="''"/>
		<xsl:with-param name="systeminfo_id"  select="/module/@systeminfo_id"/>
	</xsl:call-template>

</xsl:for-each>
</xsl:for-each>
</xsl:when>
<xsl:otherwise>
<!--property-->

<xsl:for-each select="action">

<xsl:for-each select="nativeaction[@database=$database or @database='']">
<xsl:variable name="nr" select="$nr + (position()*100)" />
<xsl:variable name="nv_uniquename" >
	<xsl:call-template name="get_nv_uniquename" >
		<xsl:with-param name="typ" select="$installOrUpgrade" />
		<xsl:with-param name="nr" select="$nr" />
	</xsl:call-template>
</xsl:variable>
<xsl:variable name="nv_caption" >
	<xsl:call-template name="get_nv_caption" >
		<xsl:with-param name="typ" select="$installOrUpgrade" />
		<xsl:with-param name="nr" select="$nr" />
	</xsl:call-template>
</xsl:variable>
<xsl:variable name="nv_step_type" >
	<xsl:call-template name="get_nv_step_type" />
</xsl:variable>
<!--<xsl:text> HIER</xsl:text>
<xsl:value-of select="concat($nv_uniquename,' ',$nv_caption,'-',$nr)"/>
-->
	<xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="$nv_uniquename"/>
		<xsl:with-param name="caption" select="$nv_caption"/>
		<xsl:with-param name="nr" select="$nr + (position()*10)"/>
		<xsl:with-param name="step_type" select="$nv_step_type"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
	</xsl:call-template>

</xsl:for-each>

<xsl:for-each select="loadtable">
<xsl:call-template name="insertStepProperty">
	<xsl:with-param name="uniquename" select="concat(/module/@name,'_',$installOrUpgrade,'_load_',@tabname)"/>
	<xsl:with-param name="caption" select="concat('Lade Tabelle ',@tabname)"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="'LOAD'"/>
	<xsl:with-param name="isFinal"  select="'0'"/>
</xsl:call-template>
</xsl:for-each>



</xsl:for-each>
</xsl:otherwise>
</xsl:choose>

</xsl:template>
<!--kopiert von git/superx/superx/xml/xsl_functions.xsl-->

<xsl:template name="search_replace">
  <xsl:param name="string" />
  <xsl:param name="search" />
<xsl:param name="replace" />
  <xsl:choose>
    <xsl:when test="not($string)" />
    <xsl:when test="contains($string, $search)">
      <xsl:value-of select="substring-before($string, $search)" />
      <xsl:value-of select="$replace" /> 
      <xsl:call-template name="search_replace">
        <xsl:with-param name="string"
                        select="substring-after($string, $search)" />
	<xsl:with-param name="search"
                        select="$search" />
	<xsl:with-param name="replace"
                        select="$replace" />
      </xsl:call-template>
    </xsl:when>
    <xsl:otherwise>
      <xsl:value-of select="$string" />
     </xsl:otherwise>
  </xsl:choose>
</xsl:template>
</xsl:stylesheet>
