<?xml version="1.0"  encoding="UTF-8" ?>

<xsl:stylesheet version="2.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:import href="etl_step_fuellen.xsl" />

<xsl:param name="sx_client"/>
<xsl:param name="dbsystem"/>
<xsl:param name="jobtype"/>

<xsl:output method="text" name="text"/>
<xsl:variable name="unknown_id" select="999999" />
<xsl:variable name="unknown" select="Unbekannt" />
<xsl:variable name="singleQuote">&#39;</xsl:variable>

<xsl:template match="/">

<xsl:text><![CDATA[
--Freemarker Template 
--Erzeugt von $ETL_PFAD/conf/etl_step_unload_fuellen.xsl
<#include "ETL_MAKROS"/>
<sqlvars>
<sqlvar name="etl_step_exists">
select  sp_table_exists('etl_step') from xdummy;
</sqlvar>
<sqlvar name="sourcesystem">
select param_val from unload_params where param_id='SOURCESYSTEM' and systeminfo_id=]]></xsl:text><xsl:value-of select="/superx-unload/module/@systeminfo_id"/><xsl:text><![CDATA[;
</sqlvar>
<sqlvar name="database">
select param_val from unload_params where param_id='DATABASE' and systeminfo_id=]]></xsl:text><xsl:value-of select="/superx-unload/module/@systeminfo_id"/><xsl:text><![CDATA[;
</sqlvar>
]]></xsl:text>
<xsl:for-each select="/superx-unload/parameters/param">
<xsl:text><![CDATA[<sqlvar name="]]></xsl:text><xsl:value-of select="@name"/><xsl:text><![CDATA[">
select replace(param_val,'''','''''') from unload_params where systeminfo_id=]]></xsl:text><xsl:value-of select="/superx-unload/module/@systeminfo_id"/><xsl:text><![CDATA[
and param_id=']]></xsl:text><xsl:value-of select="@name"/><xsl:text><![CDATA[';
</sqlvar>
]]></xsl:text>
</xsl:for-each>
<xsl:text><![CDATA[
</sqlvars>
]]></xsl:text>


<xsl:variable name="job_uniquename" select="concat(/superx-unload/module/@id,'_unload')" />
<xsl:variable name="module_name" select="/superx-unload/module/@id" />

<xsl:call-template name="initJob">
<xsl:with-param name="modulkuerzel" select="/superx-unload/module/@id"/>
<xsl:with-param name="uniquename" select="$job_uniquename" />
<xsl:with-param name="caption"  select="concat(/superx-unload/module,' Unload')" />
<xsl:with-param name="systeminfo_id"  select="/superx-unload/module/@systeminfo_id"/>
<xsl:with-param name="logfile"  select="concat('L_',/superx-unload/module/@id,'_Unload.log')" />
</xsl:call-template>

<xsl:for-each select="/superx-unload/sourcesystems/sourcesystem">
<xsl:variable name="sourcesystem" select="@name" />

<xsl:text>--Unload für sourcesystem=</xsl:text><xsl:value-of select="$sourcesystem"/><xsl:text><![CDATA[

<#if sourcesystem=="]]></xsl:text><xsl:value-of select="$sourcesystem"/><xsl:text><![CDATA["> 

--First the steps:
]]></xsl:text>
<xsl:text><![CDATA[
<#assign  etl_steps = [
]]></xsl:text>

<xsl:for-each select="/superx-unload/unload-job">
<xsl:variable name="nr" select="position()" />

<xsl:if test="extraction-sql/@sourcesystem=$sourcesystem">


<xsl:variable name="step_type">
<xsl:choose>
<xsl:when test="@transfer-unload-file=''">
<xsl:text>DOQUERY</xsl:text>
</xsl:when>
<xsl:otherwise>
<xsl:text>UNLOAD</xsl:text>
</xsl:otherwise>
</xsl:choose>
</xsl:variable>

<xsl:variable name="logfile">
<xsl:value-of select="concat('L_',$module_name,'_unload.log')"/>
</xsl:variable>

	<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($module_name,'_unload_',@id)"/>
	<xsl:with-param name="parent_uniquename" select="''"/>
	<xsl:with-param name="job_uniquename" select="$job_uniquename"/>
	<xsl:with-param name="caption" select="concat('Unload ',$module_name,' Ladeschritt ',@id)"/>
	<xsl:with-param name="nr" select="$nr"/>
	<xsl:with-param name="step_type" select="$step_type"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="logfile" select="$logfile"/>
	<xsl:with-param name="systeminfo_id"  select="/superx-unload/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'0'"/>
	</xsl:call-template>
	
</xsl:if>
</xsl:for-each>

	<xsl:call-template name="insertStep">
	<xsl:with-param name="uniquename" select="concat($module_name,'_unload_finish')"/>
	<xsl:with-param name="caption" select="concat('Ende Unload ',$module_name)"/>
	<xsl:with-param name="parent_uniquename" select="''"/>
	<xsl:with-param name="job_uniquename" select="$job_uniquename"/>
	<xsl:with-param name="nr" select="1000"/>
	<xsl:with-param name="step_type" select="'MSG'"/>
	<xsl:with-param name="force_continue" select="'0'"/>
	<xsl:with-param name="logfile" select="''"/>
	<xsl:with-param name="systeminfo_id"  select="/superx-unload/module/@systeminfo_id"/>
	<xsl:with-param name="isFinal"  select="'1'"/>
	</xsl:call-template>

<xsl:text><![CDATA[
 ] />
]]></xsl:text>

<xsl:text><![CDATA[
</#if>
]]></xsl:text>


</xsl:for-each>

<!--Ende etl_step Schleife-->


<xsl:for-each select="/superx-unload/sourcesystems/sourcesystem">

<xsl:call-template name="insertStepProperties">
<xsl:with-param name="sourcesystem" select="@name" />
<xsl:with-param name="database" select="'POSTGRES'" />
<xsl:with-param name="module_name" select="$module_name"/>
</xsl:call-template>

<xsl:call-template name="insertStepProperty">
	<xsl:with-param name="uniquename" select="concat($module_name,'_unload_finish')"/>
	<xsl:with-param name="caption" select="concat('Ende Unload ',/superx-unload/module/@name)"/>
	<xsl:with-param name="nr" select="1"/>
	<xsl:with-param name="step_type" select="'MSG'"/>
	<xsl:with-param name="isFinal"  select="'1'"/>
</xsl:call-template>
<xsl:text><![CDATA[
 ] />
]]></xsl:text>

<xsl:text><![CDATA[
</#if>
]]></xsl:text>

</xsl:for-each>




<xsl:text><![CDATA[

<#if etl_step_exists==1>

<@ETL_STEPS_FUELLEN />

</#if>

]]></xsl:text>

</xsl:template>
<xsl:template name="insertStepProperties">
<xsl:param name="sourcesystem"  />
<xsl:param name="database"  />
<xsl:param name="module_name" />
<xsl:variable name="unloadDefaultVersion"><xsl:value-of select="/superx-unload/parameters/param[@name='VERSION']/@defaultValue"/></xsl:variable>


<xsl:text>--Unload properties für sourcesystem=</xsl:text><xsl:value-of select="$sourcesystem"/>
<xsl:text>,database=</xsl:text><xsl:value-of select="$database"/>
<xsl:text>,unloadDefaultVersion=</xsl:text><xsl:value-of select="$unloadDefaultVersion"/>

<xsl:text><![CDATA[

<#if sourcesystem=="]]></xsl:text><xsl:value-of select="$sourcesystem"/>
<xsl:text>" &amp;&amp; database=="</xsl:text><xsl:value-of select="$database"/>
<xsl:text><![CDATA["> 

--then the properties:
]]></xsl:text>

<xsl:text><![CDATA[
<#assign  etl_step_properties = [
]]></xsl:text>

<xsl:for-each select="/superx-unload/unload-job">
<xsl:variable name="step_uniquename" select="concat($module_name,'_unload_',@id)" />
<xsl:variable name="nr" select="position()" />
<!-- first the params-->
<xsl:for-each select="/superx-unload/parameters/param">
<xsl:choose>
<xsl:when test="@name='JDBC_PARAM' and $sourcesystem='hisinone'">
<xsl:text><![CDATA[
  {"etl_step":"]]></xsl:text><xsl:value-of select="$step_uniquename"/>
<xsl:text>", "prop_name":"</xsl:text><xsl:value-of select="@name"/>
<xsl:text>", "prop_value":"set search_path to hisinone"</xsl:text>
<xsl:text><![CDATA[},
]]>
</xsl:text>
</xsl:when>
<xsl:otherwise>
<xsl:text><![CDATA[
  {"etl_step":"]]></xsl:text><xsl:value-of select="$step_uniquename"/>
<xsl:text>", "prop_name":"</xsl:text><xsl:value-of select="@name"/>
<xsl:text>", "prop_value":</xsl:text><xsl:value-of select="@name" />
<xsl:text><![CDATA[},
]]>
</xsl:text>
</xsl:otherwise>
</xsl:choose>
</xsl:for-each>

<!--now the extraction-sqls-->
<xsl:for-each select="extraction-sql">
<xsl:if test="@sourcesystem=$sourcesystem and (@database=$database or @database='') and (contains(@version,$unloadDefaultVersion) or @version='')">


<xsl:choose>
<xsl:when test="../@transfer-unload-file=''">
	<xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="$step_uniquename"/>
		<xsl:with-param name="caption" select="'SQL Script'"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'DOQUERY'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="sql"  select=".">
		<!--klappt nicht: <xsl:call-template name="parseSqlForUnloadParams">
		<xsl:with-param name="sql" select="." />
		</xsl:call-template>-->
		</xsl:with-param>
		<xsl:with-param name="dbconnection"  select="$sourcesystem"/>
		<xsl:with-param name="sqlVarDbconnection"  select="'eduetl'"/>
	
	</xsl:call-template>

</xsl:when>
<xsl:otherwise>
<xsl:variable name="outPath"><xsl:text>$</xsl:text><xsl:call-template name="ucase">
<xsl:with-param name="s1" select="$module_name" /></xsl:call-template><xsl:text>_LOAD_PFAD/</xsl:text>
<xsl:value-of select="../@transfer-unload-file"/></xsl:variable>
	<xsl:call-template name="insertStepProperty">
		<xsl:with-param name="uniquename" select="$step_uniquename"/>
		<xsl:with-param name="caption" select="'SQL Unload'"/>
		<xsl:with-param name="nr" select="$nr + 10"/>
		<xsl:with-param name="step_type" select="'UNLOAD'"/>
		<xsl:with-param name="isFinal"  select="'0'"/>
		<xsl:with-param name="sql"  select=".">
		<!--klappt nicht: <xsl:call-template name="parseSqlForUnloadParams">
		<xsl:with-param name="sql" select="." />
		</xsl:call-template>-->
		</xsl:with-param>
		<xsl:with-param name="outfile" select="$outPath"/>
		<xsl:with-param name="format"  select="'csv'"/>
		<xsl:with-param name="dbconnection"  select="$sourcesystem"/>
		<xsl:with-param name="sqlVarDbconnection"  select="'eduetl'"/>
	</xsl:call-template>

</xsl:otherwise>
</xsl:choose>
</xsl:if>
</xsl:for-each>

</xsl:for-each>

</xsl:template>

<xsl:template name="parseSqlForUnloadParams">
<xsl:param name="sql" />
<xsl:for-each select="/superx-unload/parameters/param">
<xsl:variable name="param_id" select="@name" />
<xsl:call-template name="search_replace">
  <xsl:with-param name="string" select="$sql"/>
  <xsl:with-param name="search" select="'a'"/>
  <xsl:with-param name="replace" select="'A'"/>
</xsl:call-template>
</xsl:for-each>
<!--<xsl:value-of select="$sql"/>
  <xsl:with-param name="search" select="concat('$',@name)"/>
  <xsl:with-param name="replace" select="concat('&quot;+',@name,'+&quot;')"/>

-->
</xsl:template>
<xsl:template name="ucase">
<xsl:param name="s1"/>
<xsl:value-of select="translate($s1,'abcdefghijklmnopqrstuvwxyz ','ABCDEFGHIJKLMNOPQRSTUVWXYZ_')" />
</xsl:template>

</xsl:stylesheet>
