/*
 * de.superx.etl - a package for controlling ETL routines
 * Copyright (C) 2021 Daniel Quathamer <danielq@memtext.de>
 *
 * This package is licensed under the CampusSource License; 
 * http://www.campussource.de/org/license/
 */
package de.superx.elt.ActionHandler;

import java.io.StringWriter;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Properties;
import java.util.logging.Logger;

import de.superx.bin.SxConnection;
import de.superx.elt.EtlStep;




public class EtlActionHandler {
	public  Properties handlerSpecificProperties;
	public  Properties runTimeParams;
	public  Logger logger;
	private String handlerType;
	protected String logOutput="";
	protected long numberOfRows=0;
	protected int returnCode;
	protected SxConnection stepSxConnection;
	protected Connection stepConnection;
	public String propFile;
	public StringWriter outputStringWriter;
	
	public EtlActionHandler(String handlerType, Properties hsp,Logger logger) {
		this.handlerType=handlerType;
		this.handlerSpecificProperties=hsp;
		this.logger=logger;
	}
	public EtlActionHandler() {
		//reflection API needs an empty constructor 
	}

	public void setReturnCode(int returnCode) {
		this.returnCode=returnCode;
	}
	public int getReturnCode() {
		
		return returnCode;
	}

	public void setNumberOfRows(long numberOfRows) {
		this.numberOfRows=numberOfRows;
	}
	public long getNumberOfRows() {
		
		return numberOfRows;
	}

	
	public void setConnection(Connection con) {
		// TODO Auto-generated method stub
		
	}
	public void setLogOutput(String log)
	{
		logOutput=log;
	}
	public String getLogOutput()
	{
		return logOutput;
	}
	public String getPropFile() {
		return propFile;
	}


	public void setPropFile(String propFile) {
		this.propFile = propFile;
	}


	public StringWriter getOutputStringWriter() {
		return outputStringWriter;
	}


	public void setOutputStringWriter(StringWriter sw) {
		this.outputStringWriter = sw;
	}


	public Properties getHandlerSpecificProperties() {
		return handlerSpecificProperties;
	}
	public void setHandlerSpecificProperties(Properties hsp) {
		this.handlerSpecificProperties = hsp;
	}
	public Properties getRunTimeParams() {
		return runTimeParams;
	}
	public void setRunTimeParams(Properties runTimeParams) {
		this.runTimeParams = runTimeParams;
	}
	public Logger getLogger() {
		return logger;
	}
	public void setLogger(Logger logger) {
		this.logger = logger;
	}
	protected void getConnection() throws SQLException {
		Statement st;
		DatabaseMetaData dbmd;
		stepSxConnection = new SxConnection();
		stepSxConnection.setPropfile(propFile);
		logger.config("Starting Connection...");
		try {
			stepConnection = stepSxConnection.getConnection();
			st = stepConnection.createStatement();
			dbmd = stepConnection.getMetaData();
		} catch (Exception e) {
			e.printStackTrace();
			logger.severe("Keine DB-Verbindung: " + e.toString());
			throw new SQLException("Keine DB-Verbindung: " + e.toString());
		}


	}			
}
