/*
 * de.superx.etl - a package for controlling ETL routines
 * Copyright (C) 2021 Daniel Quathamer <danielq@memtext.de>
 *
 * This package is licensed under the CampusSource License; 
 * http://www.campussource.de/org/license/
 */
package de.superx.elt.ActionHandler;

import java.io.File;
import java.io.StringWriter;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.Properties;
import java.util.logging.Logger;

import de.superx.bin.SxConnection;
import de.superx.elt.EtlUtils;
import de.superx.elt.QueryResultSerializer;
import de.superx.elt.SqlExecutor;

public class EtlActionHandlerDosql extends EtlActionHandler implements EtlActionHandlerI {
	
	public EtlActionHandlerDosql() {
		
	}
	@Override
    public int execute(StringWriter sw, String mandantid, String stepUniquename,String outFormat) 
    		throws SQLException, Exception
    {
    	int returnCode=0;
    	String log="";
    	long numberOfRows=0;
		this.getConnection();
		Properties myProps=EtlUtils.replaceSUPERX_DIRandETL_PFAD(handlerSpecificProperties);
		
		String filename=myProps.getProperty("PATH_TO_INPUTFILE");
		File sqlScriptFile = null;
		try {
				sqlScriptFile = new File(filename);
			} catch (Exception e1) {
				returnCode=1;
				log+=" beim Öffnen der Datei "+ filename+": "+e1.toString();
				super.setLogOutput(log);
		}
		if(returnCode==0)
		{
		try {
			SqlExecutor mySqlExecutor = new SqlExecutor("default", stepSxConnection,sqlScriptFile,runTimeParams);
			returnCode=mySqlExecutor.executeQueries();
			String output=mySqlExecutor.getOutString().toString();
			numberOfRows=mySqlExecutor.getNumberOfRows();
		} catch (Exception e) {
			returnCode=1;
			log+=" beim Ausführen der Datei "+ filename+": "+e.toString();
			super.setLogOutput(log);
		}
		super.setNumberOfRows(numberOfRows);
		}
		stepSxConnection.close();
		super.setReturnCode(returnCode);
		stepSxConnection.close();    	
		
		if(returnCode==1)
			throw new Exception("Fehler  " + log);
		//System.out.println(sw.toString());
		//super.setLogOutput(msg);
		return returnCode;
    }

}
