/*
 * de.superx.etl - a package for controlling ETL routines
 * Copyright (C) 2021 Daniel Quathamer <danielq@memtext.de>
 *
 * This package is licensed under the CampusSource License; 
 * http://www.campussource.de/org/license/
 */
package de.superx.elt.ActionHandler;

import java.io.StringWriter;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.Properties;
import java.util.logging.Logger;

import de.superx.bin.SxConnection;

public interface EtlActionHandlerI {
	
	int getReturnCode();
	long getNumberOfRows();
	StringWriter getOutputStringWriter();

	String getLogOutput();
	void setConnection(Connection con);
	void setLogger(Logger logger);
	void setHandlerSpecificProperties(Properties hsp);
	void setRunTimeParams(Properties runTimeParams);
	void setOutputStringWriter(StringWriter sw);
	
	int execute(StringWriter sw, String mandantid, String stepUniquename,String outFormat) throws SQLException,Exception;
	void setPropFile(String propfile);

}
