/*
 * de.superx.etl - a package for controlling ETL routines
 * Copyright (C) 2021 Daniel Quathamer <danielq@memtext.de>
 *
 * This package is licensed under the CampusSource License; 
 * http://www.campussource.de/org/license/
 */
package de.superx.elt.ActionHandler;

import java.io.StringWriter;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.Properties;
import java.util.logging.Logger;

import de.superx.bin.SxConnection;
import de.superx.elt.QueryResultSerializer;
import de.superx.elt.TableUploader;

public class EtlActionHandlerUploadRecords extends EtlActionHandler implements EtlActionHandlerI {
	
	public EtlActionHandlerUploadRecords() {
		
	}
	@Override
    public int execute(StringWriter sw, String mandantid, String stepUniquename,String outFormat) 
    		throws SQLException, Exception
    {
		int returnCode=0;
		this.getConnection();
		String target_table=handlerSpecificProperties.getProperty("target_table");
		String inputfile=handlerSpecificProperties.getProperty("path_to_inputfile");
		String xml_search_path=handlerSpecificProperties.getProperty("search_path");
		String format=handlerSpecificProperties.getProperty("format");
		String truncateTargetTable=handlerSpecificProperties.getProperty("truncateTargetTable");
		
		long numberOfRows=0;
		//getConnection(logger, this.getPropfile());
		TableUploader myUploader=new TableUploader();
		//myUploader.setDbpropfile(this.getPropfile());
		myUploader.setInFormat(format);
		myUploader.setTargetTable(target_table);
		myUploader.setSrcFile(inputfile);
		myUploader.setXml_search_path(xml_search_path);
		myUploader.getConnection(stepSxConnection.getConnection(),null);
		myUploader.setUploadConnection(stepSxConnection.getConnection());
		myUploader.setTruncateTargetTable(truncateTargetTable);
		numberOfRows=myUploader.uploadFile();
		super.setLogOutput("Number of rows loaded: "+numberOfRows);

	
		//System.out.println(sw.toString());
		stepSxConnection.close();    	
		//super.setLogOutput(msg);
		return returnCode;
    }

}
