/*
 * de.superx.etl - a package for controlling ETL routines
 * Copyright (C) 2021 Daniel Quathamer <danielq@memtext.de>
 *
 * This package is licensed under the CampusSource License; 
 * http://www.campussource.de/org/license/
 */
package de.superx.sxrest;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Request;
import de.memtext.util.DateUtils;
import de.superx.common.SxUser;
import de.superx.elt.EtlActionJob;
import de.superx.elt.EtlUtils;
import de.superx.servlet.SuperXManager;
import javax.servlet.http.HttpServletRequest;


@Path("/launchupgrade")

public class LaunchUpgrade {
    @Context
    Request request;

    @GET
    @Path("/{param}")
    @Produces(MediaType.TEXT_PLAIN)
    public String printXml(@PathParam("param") String componentName,@Context HttpServletRequest request) {
    	String jobOutput="";
    	String jobLog="";
    	int returnCode=0;
    	SxUser user = (SxUser) request.getSession().getAttribute("user");
    	String mandantenid= (String) request.getSession().getAttribute("MandantenID");
    	if(mandantenid==null || mandantenid.equals(""))
    		mandantenid="default";
    	
    	if (user == null || !user.isAdmin()) {
    		jobLog+="Fehlende Rechte";
    		returnCode=1;
    	}
    	else
    	{
    		String job=componentName+"_upgrade";
    		String params=componentName.toUpperCase()+"_PFAD="+SuperXManager.getWEB_INFPfad()+EtlUtils.PATHSEP+"conf"+EtlUtils.PATHSEP+"edustore"+EtlUtils.PATHSEP+"db"+EtlUtils.PATHSEP+"module"+EtlUtils.PATHSEP+componentName;
    		
    		EtlActionJob myJob=new EtlActionJob(job); //TODO:Mandantid
    		try {
    			myJob.initJob(job,params);
    		} catch (Exception e) {
    			// TODO Auto-generated catch block
    			returnCode=1;
    			jobLog+=myJob.getActionLog().toString();
    			jobLog+=e.toString();
    			jobLog+=myJob.getLogoutput();
    			
    		}
    		
    		try {
    			returnCode= myJob.execute("");
    			jobOutput+=myJob.getSw().toString();
    			jobLog+=myJob.getActionLog().toString();
    				
    		} catch (Exception e) {
    			returnCode=1;
    			jobLog+=myJob.getActionLog().toString();
    			jobLog+=e.toString();
    			jobLog+=myJob.getLogoutput();
      		}
		}
    	if(returnCode==0)
    		return "Upgrade erfolgreich: "+EtlUtils.NEWLINE+jobLog;
    	else
    		return "Upgrade mit Fehler beendet: "+EtlUtils.NEWLINE+jobLog;
    }

}
